Cns Volume Manager Cns Update Volume Crypto

Cns Volume Manager Cns Update Volume Crypto
Updates volume crypto, namely encrypt, deep recrypt, shallow recrypt, and decrypt for the container block volumes and all the disks in the chain.

Updates volume crypto, namely encrypt, deep recrypt, shallow recrypt, and decrypt for the container block volumes and all the disks in the chain.

Following privileges will be required on specified entities, to perform this operation:

  • Datastore.FileManagement on all involved datastores, required for block volumes only
  • Cryptographer.Encrypt on all involved datastores and on the virtual machines volumes are attached to, required for block volumes update encrypt
  • Cryptographer.Recrypt on all involved datastores and on the virtual machines volumes are attached to, required for block volumes update deep or shallow recrypt
  • Cryptographer.Decrypt on all involved datastores and on the virtual machines volumes are attached to, required for block volumes update decrypt

Faults that can be set in individual result entry, corresponding to each VolumeCryptoUpdateSpec instance in input:

  • vmodl.fault.InvalidArgument set in case of invalid but non-empty volume id.
  • vim.fault.NotFound set in case of the volume can not be found.
  • vim.fault.CnsFault set in case of any other failure scenario.
Request
URI
POST
https://{vcenter-host}/sdk/vim25/{release}/vsan/CnsVolumeManager/{moId}/CnsUpdateVolumeCrypto
COPY
Path Parameters
string
moId
Required

The unique identifier for the managed object to which the method attaches; the serialized managed object reference for a request has the form moType/moId, in this case CnsVolumeManager/{moId}.

string
release
Required

The vSphere release schema. The current specification covers vSphere 9.1.0.0 APIs.


Request Body
CnsUpdateVolumeCryptoRequestType of type(s) application/json
Optional
{
    "updateSpecs": [
        {
            "_typeName": "string",
            "volumeId": {
                "_typeName": "string",
                "id": "string"
            },
            "profile": [
                {
                    "_typeName": "string"
                }
            ],
            "disksCrypto": {
                "_typeName": "string",
                "parent": {
                    "_typeName": "string",
                    "parent": "DiskCryptoSpec Object",
                    "crypto": {
                        "_typeName": "string"
                    }
                },
                "crypto": {
                    "_typeName": "string"
                }
            }
        }
    ]
}
array of object
updateSpecs
Optional

Specifications for volumes to be crypted.

Authentication
This operation uses the following authentication methods.
Responses
200

Task vCenter Task to track the progress and overall state of this operation.

Returns MoRefTask of type(s) application/json
This response body class contains all of the following: MoRefExtensibleManagedObject
{
    "_typeName": "string",
    "type": "string",
    "value": "string"
}

500

InvalidArgument: if:

NotFound: if the volume can not be found.

CnsNotRegisteredFault: if the volume exists in VC but not registered as CNS volume.

CnsFault: Thrown for all other failure scenario.

Returns MethodFault of type(s) application/json
This response body class contains all of the following: Any
{
    "_typeName": "string",
    "faultCause": {
        "_typeName": "string",
        "faultCause": "MethodFault Object",
        "faultMessage": [
            {
                "_typeName": "string",
                "key": "string",
                "arg": [
                    {
                        "_typeName": "string",
                        "key": "string",
                        "value": {
                            "_typeName": "string"
                        }
                    }
                ],
                "message": "string"
            }
        ]
    },
    "faultMessage": [
        {
            "_typeName": "string",
            "key": "string",
            "arg": [
                {
                    "_typeName": "string",
                    "key": "string",
                    "value": {
                        "_typeName": "string"
                    }
                }
            ],
            "message": "string"
        }
    ]
}
faultCause
Optional

Fault which is the cause of this fault.

array of object
faultMessage
Optional

Message which has details about the error Message can also contain a key to message catalog which can be used to generate better localized messages.


Code Samples
COPY
                    curl -X POST -H 'Authorization: <value>' -H 'Content-Type: application/json' -d '{}' https://{api_host}/sdk/vim25/{release}/vsan/CnsVolumeManager/{moId}/CnsUpdateVolumeCrypto